com.tibbo.aggregate.common.binding

## Class EvaluationOptions

- java.lang.Object
- - com.tibbo.aggregate.common.binding.EvaluationOptions

- All Implemented Interfaces:
    PinpointAware, PublicCloneable, java.lang.Cloneable

      public class EvaluationOptions
      extends java.lang.Object
      implements java.lang.Cloneable, PublicCloneable, PinpointAware

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static int` | `EVENT`
    `static int` | `PERIODIC`
    `static int` | `STARTUP`
    `static int` | `TEST` The constant TEST is used to indicate the evaluation type in the context of testing.

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `EvaluationOptions()`
    `EvaluationOptions(boolean startup, boolean event)`
    `EvaluationOptions(boolean startup, boolean event, long period)`
    `EvaluationOptions(boolean startup, java.lang.String activator)`
    `EvaluationOptions(boolean startup, java.lang.String activator, java.lang.String condition)`
    `EvaluationOptions(int pattern)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `assignPinpoint(Pinpoint pinpoint)` Assigns this object with the given pinpoint
    `EvaluationOptions` | `clone()`
    `boolean` | `equals(java.lang.Object o)`
    `Reference` | `getActivator()`
    `Expression` | `getCondition()`
    `ReferenceResolver` | `getCustomDefaultReferenceResolver()`
    `int` | `getPattern()`
    `long` | `getPeriod()`
    `int` | `hashCode()`
    `boolean` | `isProcessOnEvent()`
    `boolean` | `isProcessOnStartup()`
    `boolean` | `isProcessPeriodically()`
    `java.util.Optional<Pinpoint>` | `obtainPinpoint()`
    `void` | `setActivator(Reference activator)`
    `void` | `setCondition(Expression condition)`
    `void` | `setCustomDefaultReferenceResolver(ReferenceResolver customDefaultReferenceResolver)`
    `void` | `setPattern(int pattern)`
    `void` | `setPeriod(long period)`
    `java.lang.String` | `toString()`

    - ### Methods inherited from class java.lang.Object

      `finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface com.tibbo.aggregate.common.structure.PinpointAware

      `assignPinpoint, removePinpoint`

- - ### Field Detail

    - #### STARTUP

          public static final int STARTUP

      See Also:
        Constant Field Values

    - #### EVENT

          public static final int EVENT

      See Also:
        Constant Field Values

    - #### PERIODIC

          public static final int PERIODIC

      See Also:
        Constant Field Values

    - #### TEST

          public static final int TEST

      The constant TEST is used to indicate the evaluation type in the context of testing. The value TEST signifies that the evaluation is carried out solely for testing purposes and has no impact on the user interface (UI). This is useful for distinguishing evaluation options performed within the testing framework.
      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### EvaluationOptions

          public EvaluationOptions()

    - #### EvaluationOptions

          public EvaluationOptions(boolean startup,
                                   boolean event)

    - #### EvaluationOptions

          public EvaluationOptions(boolean startup,
                                   boolean event,
                                   long period)

    - #### EvaluationOptions

          public EvaluationOptions(int pattern)

    - #### EvaluationOptions

          public EvaluationOptions(boolean startup,
                                   java.lang.String activator,
                                   java.lang.String condition)

    - #### EvaluationOptions

          public EvaluationOptions(boolean startup,
                                   java.lang.String activator)

  - ### Method Detail

    - #### getPattern

          public int getPattern()

    - #### getPeriod

          public long getPeriod()

    - #### getActivator

          public Reference getActivator()

    - #### getCondition

          public Expression getCondition()

    - #### setPattern

          public void setPattern(int pattern)

    - #### setPeriod

          public void setPeriod(long period)

    - #### setActivator

          public void setActivator(Reference activator)

    - #### setCondition

          public void setCondition(Expression condition)

    - #### isProcessOnStartup

          public boolean isProcessOnStartup()

    - #### isProcessOnEvent

          public boolean isProcessOnEvent()

    - #### isProcessPeriodically

          public boolean isProcessPeriodically()

    - #### getCustomDefaultReferenceResolver

          @Nullable
          public ReferenceResolver getCustomDefaultReferenceResolver()

    - #### setCustomDefaultReferenceResolver

          public void setCustomDefaultReferenceResolver(@Nullable
                                                        ReferenceResolver customDefaultReferenceResolver)

    - #### clone

          public EvaluationOptions clone()

      Specified by:
        `clone` in interface `PublicCloneable`
      Overrides:
        `clone` in class `java.lang.Object`

    - #### equals

          public boolean equals(java.lang.Object o)

      Overrides:
        `equals` in class `java.lang.Object`

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `java.lang.Object`

    - #### toString

          public java.lang.String toString()

      Overrides:
        `toString` in class `java.lang.Object`

    - #### assignPinpoint

          public void assignPinpoint(Pinpoint pinpoint)
                              throws java.lang.IllegalStateException

      Description copied from interface: `PinpointAware`
      Assigns this object with the given pinpoint
      Specified by:
        `assignPinpoint` in interface `PinpointAware`
      Parameters:
        `pinpoint` - a pinpoint this object should be associated with
      Throws:
        `java.lang.IllegalStateException` - in case pinpoint cannot be assigned after object construction

    - #### obtainPinpoint

          public java.util.Optional<Pinpoint> obtainPinpoint()

      Specified by:
        `obtainPinpoint` in interface `PinpointAware`